var Core = require('core');
var RenderingController = require("./RenderingController.js").RenderingController;

var RenderMethod = function () {
    this.Extends = Core.JsonRpc.JsonRpcMethod;
    
    this.execute = function (params) {
         try {
            var controller = new RenderingController(params, this.server.api, this.server.getTemplatePath());
            controller.addEventListener(RenderingController.RENDERED, this._onSuccess, this);
            controller.addEventListener(RenderingController.ERROR, this._onError, this);
            controller.render();
         } catch(e) {
            this._onError(e);
         }
    };
    
    this._onSuccess = function(e){
        console.log('  -- RenderMethod: COMPLETE. sending response...');        
        this.dispatchEvent( new Core.Event.Event(Core.JsonRpc.JsonRpcMethod.Event.OK, e.data) );
    };

    this._onError = function(e){
        console.log('  -- RenderMethod: ERROR. sending error response...');
        if(typeof e ==='string'){
            console.log('     -- ' + e);
        } else {
            console.log('     -- ' + e.code + ': ' + e.message);
        }        
        this.dispatchEvent( new Core.Event.Event(Core.JsonRpc.JsonRpcMethod.Event.ERROR, e) );
    };
};

RenderMethod = new Core.Class(new RenderMethod());
exports.RenderMethod = RenderMethod;