var Core = require('core');
var TemplateApi = require("./TemplateApi.js").TemplateApi;
var Event = require('core').Event;

var TemplateApiManager = function(){
    this.Extends = Event.EventDispatcher;
    
    this._objects = [];
    this._counter = 0;
    this._isError = false;
    
    this.initialize = function(){};
    
    this.add = function(obj){
        obj.addEventListener(TemplateApi.Event.READY, this._onReady, this);
        obj.addEventListener(TemplateApi.Event.ERROR, this._onError, this);
        this._objects.push(obj);
        this._counter++;
    };
    
    this._onReady = function(e){
        this._counter--;
        if(this._counter==0 && this._isError==false){
            this.dispatchEvent(new Event.Event(TemplateApiManager.Event.READY));
        }
    };
    
    this._onError = function(e){
        this._isError = true;
        this.dispatchEvent(new Event.ErrorEvent(TemplateApiManager.Event.ERROR, e));
    };
    
    this.start = function(){
        if(this._objects.length==0){
            this.dispatchEvent(new Event.Event(TemplateApiManager.Event.READY));
            return;
        }        
        for(var i=0,max=this._objects.length;i<max;i++){
            try{
                this._objects[i].start();
            } catch(e) {
                this.dispatchEvent(new Event.ErrorEvent(TemplateApiManager.Event.ERROR, e));
            }
        }
    };
};

TemplateApiManager = new Core.Class(new TemplateApiManager());
TemplateApiManager.Event = {};
TemplateApiManager.Event.READY = "TemplateApiManager.Event.READY";
TemplateApiManager.Event.ERROR = "TemplateApiManager.Event.ERROR";
exports.TemplateApiManager = TemplateApiManager;