var Class           = require('core').Class;
var EventDispatcher = require('core').Event.EventDispatcher;

var PluginAbstract = function(){

    this.Extends = EventDispatcher;
    
    this._config = null;
    
    this.initialize = function(config){
        this._config = config;
    };
    
    this.execute = function(){
        throw PluginAbstract.Exception.LOAD_NOT_IMPLEMENTED;
    };
};


PluginAbstract = new Class(new PluginAbstract());

PluginAbstract.Event = {};
PluginAbstract.Event.READY = "PluginAbstract_READY";
PluginAbstract.Event.ERROR = "PluginAbstract_ERROR";

PluginAbstract.Exception = {};
PluginAbstract.Exception.INITIALIZE_NOT_IMPLEMENTED = "Method::initialize() - not implemented!";
PluginAbstract.Exception.LOAD_NOT_IMPLEMENTED = "Method::load() - not implemented!";

exports.PluginAbstract = PluginAbstract;