var Core = require('core');
var PluginAbstract = require("./PluginAbstract.js").PluginAbstract;
var Event = require('core').Event;

var PluginManager = function(){
    this.Extends = Event.EventDispatcher;
    
    this._objects = [];
    this._counter = 0;
    this._actualIndex = 0;
    this._isError = false;
    
    this.initialize = function(){};
    
    this.add = function(obj){
        obj.addEventListener(PluginAbstract.Event.READY, this._onReady, this);
        obj.addEventListener(PluginAbstract.Event.ERROR, this._onError, this);
        this._objects.push(obj);
        this._counter++;
    };
    
    this._onReady = function(e){
        this._counter--;
        this._actualIndex++;
        if(this._counter==0 && this._isError==false){
            this.dispatchEvent(new Event.Event(PluginManager.Event.READY, e.data));
        } else {
            this._objects[this._actualIndex].execute(e.data, this._params);
        }
    };
    
    this._onError = function(e){
        this._isError = true;
        this.dispatchEvent(new Event.ErrorEvent(PluginManager.Event.ERROR, e));
    };
    
    this.start = function(content, params){
        this._params = params;
        if(this._objects.length==0){
            this.dispatchEvent(new Event.Event(PluginManager.Event.READY));
            return;
        }
        this._objects[this._actualIndex].execute(content, params);
    };
};

PluginManager = new Core.Class(new PluginManager());
PluginManager.Event = {};
PluginManager.Event.READY = "PluginManager.Event.READY";
PluginManager.Event.ERROR = "PluginManager.Event.ERROR";
exports.PluginManager = PluginManager;