var Class           = require('core').Class;
var Event       = require('core').Event.Event;
var ErrorEvent  = require('core').Event.ErrorEvent;
var EventDispatcher = require('core').Event.EventDispatcher;

var PluginAbstract  = require('./PluginAbstract.js').PluginAbstract;

var scss = require('scss');

var Scss = function(){

    this.Extends = PluginAbstract;
    
    
    this.execute = function(data, params){
        console.log('     -- SCSS plugin execute');
        
        data = this._prepareArguments(data, params);
        
        var that = this;
        scss.parse(data, function(err, css){
            if(err) {
                console.log('     -- SCSS dispatch ERROR -> SCSS Internal Error');
                that.dispatchEvent(new ErrorEvent(PluginAbstract.Event.ERROR, err, -31996, 'SCSS internal error'));
            } else {
                if(css==""){
                    console.log('     -- SCSS dispatch ERROR -> Empty response from SCSS');
                    that.dispatchEvent(new ErrorEvent(PluginAbstract.Event.ERROR, data, -31997, 'empty response from SCSS'));
                } else {
                    console.log('     -- SCSS dispatch READY');
                    that.dispatchEvent(new Event(PluginAbstract.Event.READY, css));
                }
            }
        });
    };
    
    this._prepareArguments = function(data, args){
        var retVal = "";
        for(var prop in args.params){
            retVal += "$" + prop + ": " + args.params[prop] + ";\n";
        }
        return retVal + data;
    };
    
};

Scss = new Class(new Scss());
exports.Scss = Scss;