var Fs = require('fs');
var Class = require('core').Class;
var Router = require('./Router.js').Router;
var DevRoute = require('./DevRoute.js').DevRoute;

var CdfYaml = require('../cdf/CdfYaml.js').CdfYaml;

var actionFilePattern = /([\w\d\/]*)\.yaml$/

var DevRouter = function(){
    this.Extends = Router;
    
    this.actionsPath = null;
    this.actions = null;
    
    this.initialize = function(actionsPath){
        console.log("DevRouter");
        this.parent();
        this.actionsPath = actionsPath;
        this.actions = {};
        this._retrieveCdfActionsFromDir("");
    };
    
    this._retrieveCdfActionsFromDir = function(dirName){
        var fullPath = this.actionsPath + dirName
        var dir = Fs.readdirSync(fullPath), 
            parts = null, 
            actionConf = null, 
            token = null,
            fileStat = null,
            filePath = null;
        
        for(var i = 0; i < dir.length; i++){
            filePath = fullPath + dir[i];
            //console.log(filePath);
            fileStat = Fs.statSync(filePath)
            if(fileStat.isFile()){
                parts = (dirName + dir[i]).match(actionFilePattern)
                if(parts){
                    try {
                        token = parts[1];
                        console.log("* Action from file: " + filePath + " added as \"" + token + "\".");
                        this.actions[token] = CdfYaml.parseFileSync(filePath);
                        var route = new DevRoute(token);
                        this.addRoute(route);
                    }
                    catch(err){
                        console.log("Error occured while adding route:", err.message, err.stack);
                    }   
                }
            }
            else{
                this._retrieveCdfActionsFromDir( dirName + dir[i] + "/");
            }
        }
    };    
};
DevRouter = new Class( new DevRouter() );
exports.DevRouter = DevRouter;