var Fs = require('fs');
var Class = require('core').Class;
var Router = require('./Router.js').Router;
var ResourceRoute = require('./ResourceRoute.js').ResourceRoute;

var Yaml = require('core').Yaml.YAML;

var ResourceRouter = function(){
    this.Extends = Router;
    this.config = null;
    this.resourcePath = null;
    
    this.initialize = function(resourcePath){
        console.log("ResourceRouter");
        this.resourcePath = resourcePath;
        var resourceConfigPath = this.resourcePath + "resources.yaml"
        this.config = Yaml.parseFileSync(resourceConfigPath).pop();
        this.parent();
        this._prepareActions();
    };
    
    this._prepareActions = function(){
        if(this.config.hasOwnProperty('files')){
            for(var file in this.config.files){
                var route = new ResourceRoute(file, this.resourcePath );
                this.addRoute(route);
                console.log("* Resource: " + file + " added as \"" + file + "\".");
            }
        }
    };
};
ResourceRouter = new Class( new ResourceRouter() );
exports.ResourceRouter = ResourceRouter;