var Class = require('core').Class;
var EventDispatcher = require('core').Event.EventDispatcher;
var Event = require('core').Event.Event;

var Router = function(){
    this.Extends = EventDispatcher;
    this.routes = null;
    this.initialize = function(){
        this.routes = [];  
    };
    this.addRoute = function( route ){
        this.routes.push(route);
    };
    this.run = function( request ){
        var count = this.routes.length, i = 0;
        while(i < count && !this.routes[i].match(request)){
            i++;
        }
        if(i < count){
            this.dispatchEvent(new Event(Router.Event.COMPLETE, this.routes[i]));
            return;
        }
        this.dispatchEvent(new Event(Router.Event.ERROR, null));
    };
};
Router = new Class( new Router() );
Router.Event = {};
Router.Event.COMPLETE = "ROUTE_FOUND";
Router.Event.ERROR = "ROUTE_NOT_FOUND";
exports.Router = Router;