var Fs = require('fs');
var Class = require('core').Class;
var Router = require('./Router.js').Router;
var StaticRoute = require('./StaticRoute.js').StaticRoute;

var CdfYaml = require('../cdf/CdfYaml.js').CdfYaml;

var StaticRouter = function(){
    this.Extends = Router;
    
    this.resourcePath = null;
    
    this.initialize = function(resourcePath){
        console.log("StaticRouter");
        this.parent();
        this.resourcePath = resourcePath;
        this._retrieveResourceActionsFromDir("");
    };
    
    this._retrieveResourceActionsFromDir = function(dirName){
        var fullPath = this.resourcePath + dirName
        var dir = Fs.readdirSync(fullPath), 
            parts = null, 
            token = null,
            fileStat = null,
            filePath = null;
        
        for(var i = 0; i < dir.length; i++){
            filePath = fullPath + dir[i];
            fileStat = Fs.statSync(filePath)
            if(fileStat.isFile()){
                try {
                    token = filePath;
                    
                    var route = new StaticRoute(token);
                    this.addRoute(route);
                    console.log("* Static file: " + filePath + " added as \"" + token + "\".");
                }
                catch(err){
                    console.log("Error occured while adding route:", err.message, err.stack);
                }   
            }
            else{
                this._retrieveResourceActionsFromDir( dirName + dir[i] + "/");
            }
        }
    };    
};
StaticRouter = new Class( new StaticRouter() );
exports.StaticRouter = StaticRouter;